#+OPTIONS: num:nil toc:nil
#+REVEAL_TRANS: None
#+REVEAL_THEME: Solarized
#+Title: Reproducibility in Comparative Genomics
#+Subtitle: MPB Department Seminar
#+Author: Carsten Fortmann-Grote
#+Email: carsten.fortmann-grote@evolbio.mpg.de
#+Mastodon: @c4r510
#+DATE:      January 8 2024
#+DESCRIPTION: Presentation at the MPB Department Seminar on January 8 2025
#+KEYWORDS: good scientific practice, open science, software Development, snakemake, conda, containerization, apptainer, mpcdf, gwdg, python, bioinformatics, raxml, phylogeny, clonalframeml, pipeline 
#+LANGUAGE:  en
#+OPTIONS:   H:2 num:t toc:nil \n:nil @:t ::t |:t ^:t -:t f:t *:t <:t email:t
#+OPTIONS:   TeX:t LaTeX:t skip:nil d:nil todo:t pri:nil tags:not-in-toc
#+INFOJS_OPT: view:nil toc:nil ltoc:t mouse:underline buttons:0 path:https://orgmode.org/org-info.js
#+EXPORT_SELECT_TAGS: export
#+EXPORT_EXCLUDE_TAGS: noexport
#+HTML_LINK_UP:
#+HTML_LINK_HOME:
#+startup: beamer
#+LaTeX_CLASS: beamer
#+LaTeX_CLASS_OPTIONS: [bigger,aspectratio=169]
#+BEAMER_FRAME_LEVEL: 2
#+COLUMNS: %40ITEM %10BEAMER_env(Env) %9BEAMER_envargs(Env Args) %4BEAMER_col(Col) %10BEAMER_extra(Extra)
#+latex_header: \mode<beamer>{\usetheme{Madrid}}
#+BEAMER_HEADER: \title{Reproducibility in Comparative Genomics}
#+latex_header: \usepackage[style=authoryear,maxcitenames=1,url=false,eprint=false]{biblatex}
#+latex_header: \usepackage{tikz}
#+latex_header: \usepackage{pgfpages}
#+latex_header: \usepackage{marvosym}
#+latex_header: \usepackage{caption}
#+latex_header: \usepackage{hyperxmp}
#+latex_header: \hypersetup{pdfauthor={Carsten Fortmann-Grote},
#+latex_header: pdfdate={2025-01-08T09:00},
#+latex_header: pdftitle={Reproducibility in Comparative Genomics},
#+latex_header: pdfkeywords={good scientific practice, open science, software Development, snakemake, conda, containerization, apptainer, mpcdf, gwdg, python, bioinformatics, raxml, phylogeny, clonalframeml, pipeline},
#+latex_header: pdfsubject={MPB Department Seminar},
#+latex_header: pdfcreator={Emacs 28.2 (Org mode 9.7.4)},
#+latex_header: pdflang={English},
#+latex_header: pdfcontactemail={carsten.fortmann-grote@evolbio.mpg.de},
#+latex_header: pdfpubtype={presentation},
#+latex_header: pdfpublication={},
#+latex_header: pdflicenseurl={https://creativecommons.org/licenses/by/4.0/deed.en},
#+latex_header: pdfcopyright={Max-Planck-Gesellschaft zur Förderung der Wissenschaften e.V.}
#+latex_header: }
#+latex_header: \usetikzlibrary{shapes.geometric}
#+latex_header: \usetikzlibrary{positioning}
#+latex_header: \usetikzlibrary{calc}
#+latex_header: \usetikzlibrary{arrows}
#+latex_header: \usetikzlibrary{tikzmark}
#+latex_header: \usetikzlibrary{decorations.pathmorphing}
#+latex_header: \input{resources/colors}
#+latex_header: \definecolor{mpievolbio_green}{RGB}{0,124,119}
#+latex_header: \setbeamercolor*{frametitle}{fg=white,bg=MPGGreen}
#+latex_header: \setbeamercolor*{section in head/foot}{fg=white,bg=MPGGreen}
#+latex_header: \setbeamercolor*{date in head/foot}{fg=white,bg=MPGGreen}
#+latex_header: \setbeamercolor*{author in head/foot}{fg=white,bg=MPGGreen}
#+latex_header: \setbeamercolor*{title in head/foot}{fg=white,bg=MPGGreen}
#+latex_header: \setbeamercolor{structure}{bg=MPGGreen}
#+latex_header: \setbeamercolor{block title}{fg=white,bg=structure.bg}
#+latex_header: \setbeamercolor{block body}{use=block title,bg=block title.bg!10}
#+latex_header: \setbeamercolor{title}{fg=white,bg=MPGGreen}
#+latex_header: \setbeamercolor{itemize item}{fg=MPGGreen}
#+latex_header: \setbeamercolor{itemize subitem}{fg=MPGGreen}
#+latex_header: \setbeamercolor{enumerate item}{fg=MPGGreen}
#+latex_header: \setbeamercolor{enumerate subitem}{fg=MPGGreen}
#+latex_header: \setbeamercolor{description item}{fg=MPGGreen}
#+latex_header: \setbeamertemplate{itemize item}[circle]
#+latex_header: \setbeamertemplate{itemize subitem}[circle]
#+latex_header: \setbeamertemplate{itemize subsubitem}[circle]
#+latex_header: \setbeamercolor{alerted text}{fg=MPGOrange,bg=MPGLightGreen}
#+latex_header: \addbibresource{jabref.bib}
#+latex_header: \captionsetup{labelformat=empty, font={tiny,rm,color=black}}
#+latex_header: \AtEveryBibitem{\clearfield{issn}}
#+latex_header: \AtEveryBibitem{\clearfield{url}}
#+latex_header: \AtEveryBibitem{\clearfield{urldate}}
#+beamer_header: \logo{\includegraphics[width=0.05\textwidth]{cc-by.png}\hspace{.02\textwidth}\hspace{.02\textwidth}\includegraphics[width=0.05\textwidth]{images/mpg_logo_FGgreen_BGalpha}}

* Recombination in closely related Pseudomonas strains
:PROPERTIES:
:ID:       868526be-1692-422e-a9c5-416e395ffeb0
:END:
** Headline                                                     :B_fullframe:
:PROPERTIES:
:BEAMER_env: fullframe
:ID:       9ae205d0-9c8e-4601-90b3-98de47641d3b
:END:
#+begin_export beamer
\begin{center} \vspace*{\fill}\Huge\insertsection\vspace*{\fill}
\end{center}
#+end_export
***                                                                  :B_note:
:PROPERTIES:
:BEAMER_env: note
:ID:       7fc3f499-18ee-4c15-ae6a-c9fa3ebfe728
:END:
Finally, I want to present a small experiment. In the experiment I try to follow
the recommendations for reproducible research software engineering in HPC as good
as possible and then evaluate how reproducible the results really are. 
** Genetic Recombination in Microbial Evolution
:PROPERTIES:
:BEAMER_env: frame
:ID:       c89d688c-c41e-462a-a780-b78abdf16e6b
:END:
***                                                               :B_columns:
:PROPERTIES:
:BEAMER_env: columns
:ID:       7302a2de-e4e1-4f26-87b4-a2ad09529f2e
:END:
****                                                               :B_column:
:PROPERTIES:
:BEAMER_env: column
:beamer_col: .49
:beamer_opt: t
:ID:       f4cd8a1c-90e6-49ef-8c2c-322906598393
:END:
***** Clonal genealogy                                              :B_block:
:PROPERTIES:
:BEAMER_env: block
:ID:       65a83cda-827d-442e-b15f-597892ac3353
:END:
- Clonal reproduction through cell division 
- Genome diversity by point mutations
- Clonal phylogeny inferred by Max. Likelihood  (PhyML, RAxML, FastTree) or Bayesian Inference (MrBayes, BEAST)
****                                                               :B_column:
:PROPERTIES:
:ID:       6421a690-0156-4404-8607-5038da894da1
:BEAMER_env: column
:beamer_col: .49
:beamer_opt: t
:beamer_act: <2->
:END:
***** Homologous recombination                                      :B_block:
:PROPERTIES:
:BEAMER_env: block
:ID:       c58c0de2-81aa-4a1b-84bd-7667d97f8e43
:END:
- Transduction (phage mediated)
- Transformation (environmental DNA)
- Conjugation (DNA exchange)
- Varying rates of recombination among species and lineages
- Hides or distorts "true" relationships among species/lineages
** ClonalFrameML: Max. Likelihood Inference of Recombination        :B_frame:
:PROPERTIES:
:BEAMER_env: frame
:ID:       84cf2879-ee26-426e-8db6-2bd4a70132e5
:END:
***                                                               :B_onlyenv:
:PROPERTIES:
:BEAMER_env: onlyenv
:beamer_act: <1>
:ID:       9b3842fd-97eb-425e-b9d8-c8d66d895ac7
:END:
**** Pipeline                                                       :B_block:
:PROPERTIES:
:ID:       14121070-52cf-465d-998c-28478ba835f7
:BEAMER_env: block
:beamer_col: .49
:END:
#+beamer: {\footnotesize
1. Whole genome alignment
2. Max. Likelihood Phylogeny (PhyML, RAxML, FastTree, ...)
3. Reconstruction of parental sequences at internal nodes
4. Estimation of recombination parameters and branch lengths of clonal phylogeny
5. Estimation of importation status 
6. Estimation of uncertainties 
#+beamer:}
****                                                                :B_block:
:PROPERTIES:
:BEAMER_env: block
:ID:       7f040397-8986-4acb-b057-b5462e0ad0e8
:END:
\fullcite{Didelot2015}


***** Notes                                                        :B_noteNH:
:PROPERTIES:
:BEAMER_env: noteNH
:beamer_act: <3>
:ID:       63ede9d9-0352-4fdf-8be2-5fc6b187ff2b
:END:
I start from 20 sequences of bacterial genomes from
closely related strains of the species /Pseudomonas fluorescens/. The alignment
is done by a tool called =progressiveMauve=, which, unlike other codes, is able
to infer genetic rearrangements, not just point mutations. The alignment is then cleaned up, filtered, and
reformatted using specialized filter tools and a small pipeline that combines various unix commands and a perl script.
Then, a maximum-likelihood inference tool called RaXML infers the most likely phylogeny before both the alignment and
the phylogeny are fed into the ClonalFrameML algorithm which produces, besides others, a text file with the mean
and standard deviations of the posterior distributions of the model that expresses the likelihood of recombination occurring
at a given nucleotide position in the aligned genomes.
***                                                               :B_onlyenv:
:PROPERTIES:
:BEAMER_env: onlyenv
:beamer_act: <2>
:ID:       fc32aed2-2a84-4671-9a64-87aabf01a116
:END:
**** ClonalFrameML outputs                                          :B_block:
:PROPERTIES:
:ID:       e9cf4820-46ab-4280-895c-b882d453678f
:BEAMER_env: block
:END:
***** Didelot2015
:PROPERTIES:
:BEAMER_col: .49
:ID:       3f378b6d-f679-41d5-81f5-9551cdd77306
:END:
#+DOWNLOADED: screenshot @ 2024-10-27 23:29:56
#+attr_latex: :height .5\textheight
#+caption: Didelot2015: Simulated genealogy, true (blue) and inferred (red) recombination events
[[file:img/A_small_investigation_of_reproducibility_in_High_Throughput_Bioinformatics/2024-10-27_23-29-56_screenshot.png]]
***** Parameters
:PROPERTIES:
:BEAMER_col: .49
:ID:       aea6e42e-bc76-4d49-af40-edc33ec7bd5d
:END:
- $R/2$: recombination rate
- $\theta/2$: mutation rate
- $\delta$: mean length of segments affected by recombination
- $\nu$: prob. of substitution per site
#+beamer:{\footnotesize
| Parameter  | Posterior Mean | Posterior SD |
|------------+----------------+--------------|
| $R/\theta$ |            0.1 |         6e-4 |
| $1/\delta$ |           0.03 |       1.3e-4 |
| $\nu$      |            0.1 |         3e-4 |
#+beamer:}

recombination / mutation = $R/\theta\cdot\delta\cdot\nu$
***** Notes                                                        :B_noteNH:
:PROPERTIES:
:BEAMER_env: noteNH
:beamer_act: <2>
:ID:       2cc4f69d-00d7-4531-af1f-84341840798d
:END:
These processes, also referred to a genetic recombination events, are not
accounted for by the phylogenetic inference methods. Currently, there are a few
methods to reconstruct the likelihood of recombination from the alignment and
the tree computed without assuming recombination. One of these methods is
ClonalFrameML. ClonalFrameML is a Bayesian inference algorithm that basically
produces a probability for recombination events having happened in total and per
genome.

** Analysis of 20 P.flu SBW25 relatives 
:PROPERTIES:
:BEAMER_env: frame
:ID:       e02c54a5-49dc-43ab-b21e-b230f6b1f6a6
:END:
***                                                               :B_onlyenv:
:PROPERTIES:
:BEAMER_env: onlyenv
:beamer_act: <1>
:ID:       b49eb7f8-d4f9-4f11-83d8-37498f720059
:END:
**** ML tree and recombination events in 20 *Pseudomonas* strains   :B_block:
:PROPERTIES:
:BEAMER_env: block
:ID:       1f5e584b-5729-40ee-ae66-a5b618f48854
:END:
#+attr_latex: :width .9\textwidth
#+caption: Genome data provided by Dave Rogers, Kaumudi Prabhakara
[[file:images/cfml_results_fasttree-raxml-crop.pdf]]

****                                                               :B_noteNH:
:PROPERTIES:
:BEAMER_env: noteNH
:ID:       0da8a98f-8096-4d10-be12-7e77a6eca3dd
:END:
We ran the pipeline, and I'll show you the results which basically mean that there is only little recombination happening in these
lineages. So far so good. Now, I got a bit curious because we ran the same pipeline on a few computers and got some differences. Not so
much difference that it would make a qualitatively different results but yet the differences where larger (2 orders of magnitude)
than what the posterior distributions indicate. Ok, so let's try to make this a reproducible as possible and follow best practices
for research software engineering.

***                                                               :B_onlyenv:
:PROPERTIES:
:BEAMER_env: onlyenv
:beamer_act: <2>
:ID:       11715e1d-21a9-4688-b745-2871c8c2eedf
:END:
**** Model parameters                                               :B_block:
:PROPERTIES:
:BEAMER_env: block
:ID:       eb146b14-de3c-40f9-82e8-32cf982f003d
:END:

| Aligner | Phylogeny | $R/\theta$ | $1/\delta$ | $\nu$ |
|---------+-----------+------------+------------+-------|
| Mauve   | RAxML     |       0.12 |      0.026 |  0.10 |


***                                                               :B_onlyenv:
:PROPERTIES:
:BEAMER_env: onlyenv
:beamer_act: <3>
:ID:       f8b946fc-bcae-4924-a76e-f5049a52772e
:END:

**** Posterior means                                                :B_block:
:PROPERTIES:
:BEAMER_env: block
:ID:       5797149f-05dc-4de0-8647-fb6e6f5a76da
:END:

| Aligner | Phylogeny | $R/\theta$ | $1/\delta$ | $\nu$ | $R/m$   |
|---------+-----------+------------+------------+-------+---------|
| Mauve   | RAxML     |       0.12 |      0.026 |  0.10 |    0.46 |
| Mauve   | RealPhy   |       0.12 |      0.026 | 0.098 |    0.45 |
|---------+-----------+------------+------------+-------+---------|
| RealPhy | RAxML     |       1.02 |      0.002 | 0.008 |    4.08 |
| RealPhy | RealPhy   |       1.01 |      0.002 | 0.008 |    4.04 |
#+TBLFM: $6=$3*$5/$4


***                                                               :B_onlyenv:
:PROPERTIES:
:BEAMER_env: onlyenv
:beamer_act: <4>
:ID:       15fe1235-c99a-42f9-a38c-b55d55292829
:END:
**** Results strongly depend on the alignment tool
:PROPERTIES:
:BEAMER_env: block
:ID:       daa8daa2-397b-4e13-9127-46c36af04dc3
:END:

#+attr_latex: :width .6\textwidth
#+caption: ClonalFrameML results strongly depend on the aligner
[[file:cfml_results_pipes.pdf]]
***                                                               :B_onlyenv:
:PROPERTIES:
:BEAMER_env: onlyenv
:beamer_act: <5>
:ID:       582dce77-9354-436c-a9ca-ef897a25404b
:END:
**** Reproducibility?                                               :B_block:
:PROPERTIES:
:BEAMER_env: alertblock
:ID:       daa8daa2-397b-4e13-9127-46c36af04dc3
:END:

- How repeatable is a given pipeline result?
- On a given compute system?
- Across multiple systems?
- In a HPC cluster?
- Expect random variations on the level of reported uncertainties
#+beamer: \pause
- Observe discretely distributed fluctuations orders of magnitude larger than reported uncertainties

:PROPERTIES:
:BEAMER_env: frame
:END:
* Factors reducing reproducibility in scientific computing
:PROPERTIES:
:ID:       4beb9cd6-b0f3-4608-993e-8163b7bcc0a8
:END:
:LOGBOOK:
CLOCK: [2025-01-06 Mon 11:24]--[2025-01-06 Mon 11:49] =>  0:25
:END:
** Headline                                                     :B_fullframe:
:PROPERTIES:
:BEAMER_env: fullframe
:ID:       c7e87b2b-2751-4a15-816b-0c278764913d
:END:
#+begin_export beamer
\begin{center} \vspace*{\fill}\Huge\insertsection\vspace*{\fill}
\end{center}
#+end_export
** Causes of reproducibility loss                                   :B_frame:
:PROPERTIES:
:BEAMER_env: frame
:ID:       e0ff0bb7-9d8d-4ebd-a2d0-46dc5e7e66e1
:END:
***                                                                 :B_block:
:PROPERTIES:
:BEAMER_env: block
:ID:       39987799-b522-4ca7-9638-6f819a7df1db
:END:
#+DOWNLOADED: screenshot @ 2024-10-22 18:03:14
#+caption: Reasons of reproducibility loss \parencite{Antunes2024}
#+name: antunes2024_fig1
#+attr_latex: :width .7\textwidth
[[file:img/Slides/2024-10-22_18-04-47_screenshot.png]]
*** Notes                                                          :B_noteNH:
:PROPERTIES:
:BEAMER_env: noteNH
:ID:       3c4ac4f3-461d-45b6-96d9-66e40d24ed3a
:END:
In a very recent review on the subject, Antunes and Hill discuss various factors reducing
reproducibility in Scientific Computing in general and more specifically in high performance computing
in terms of global factors and in terms of user dependent factors
:PROPERTIES:
:BEAMER_env: frame
:ID:       47a38b38-36e9-4d4b-bf11-a35d2bb68751
:END:
***                                                                 :B_block:
:PROPERTIES:
:BEAMER_env: block
:beamer_col: .33
:beamer_opt: t
:ID:       98efcccd-81c0-4e4f-adf7-c1f8fab431d9
:END:
  - P-value hacking
  - HARKing
***                                                                 :B_block:
:PROPERTIES:
:BEAMER_env: block
:beamer_col: .66
:beamer_opt: t
:ID:       02edf5e2-5ddb-4f87-8dda-7d93c97af54c
:END:
#+attr_latex: :height .67\textheight
#+caption: http://xkcd.com/2400
[[file:images/statistics.png]]
***                                                                  :B_note:
:PROPERTIES:
:BEAMER_env: note
:ID:       754169f8-048a-4d37-95b0-d79ab7acdfdb
:END:
P-value hacking and HARKing are probably just the two most well known examples of how badly executed statistics can hamper if not make impossible
any attempt at reproducing a study. I'll not go into further details but the previous speaker will gladly add more to the topic if needed ;)
** Software environment                                             :B_frame:
:PROPERTIES:
:BEAMER_env: frame
:ID:       336b2245-ee4d-4780-b3e8-f81c6a36c7d9
:END:
***                                                               :B_onlyenv:
:PROPERTIES:
:BEAMER_env: onlyenv
:beamer_act: <1>
:ID:       1f3b1c52-60fb-4872-954b-c71018952ec6
:END:
****                                                                :B_block:
:PROPERTIES:
:BEAMER_env: block
:ID:       9c5d5a9f-217f-4988-95ff-dbd539f6c482
:END:
- Software programs are never monolithic but have dependencies
- Changes in dependent libraries cause incompatibilities
- What works on one system is not guaranteed to work on another system
- Portability across operating systems and hardware often limited
- Possible solution: Rely entirely on closed source frameworks (Geneious, mathematica, matlab) \parencite{Hinsen2020}
- Open source software: Package managers (conda, CRAN, BioConductor)
**** Notes                                                         :B_noteNH:
:PROPERTIES:
:BEAMER_env: noteNH
:ID:       2485bd34-0fc4-4267-8a43-3ef9658ab043
:END:
The vast abundance of scientific software is not monolithic but rather relies on a plethora of numerical, statistical, graphics and other libraries. Not only
are these easy to use but in many cases also provide the best option in terms of performance because they are developed by professional software engineers. Anyone who has ever tried to
implement a fast fourier transform or a matrix diagonalization and not use fftw or MKL will know what I'm talking about. Nevertheless, also professionally managed software libraries have bugs, and
if bugs are fixed, new versions are released. For various reasons, library B may not be compatible anymore with the new version of library A. But even if all libraries are still compatible, the new version of code A
may use a ever so slightly different memory allocation in one of the algorithms needed to produce that one figure in the last paper and now
the precise number does not come out anymore. Maybe nothing to worry about but in terms of bitwise reproducibility, it sure is. Also, one set of versions may work on one system but is far from guaranteed
to work on all systems and operating systems.
***                                                               :B_onlyenv:
:PROPERTIES:
:BEAMER_env: onlyenv
:beamer_act: <2>
:ID:       2b690a2b-ba5f-4bdb-ac02-1f566e9db6c5
:END:
**** =environment.yml=                                              :B_block:
:PROPERTIES:
:ID:       ac4c9466-d9c9-4159-9af5-5cfed4083194
:BEAMER_env: block
:END:
*****                                                             :B_columns:
:PROPERTIES:
:BEAMER_env: columns
:ID:       35709dfc-d367-465d-8632-6343069ab6c6
:END:
******                                                             :B_column:
:PROPERTIES:
:BEAMER_env: column
:beamer_col: .49
:beamer_opt: t
:ID:       ab3fbeab-5833-4481-828f-3ae2b27305e8
:END:
#+begin_example
channels:
  - nodefaults
  - bioconda
  - conda-forge
dependencies:
  - python=3.12
  - snakemake>=8.20
  - biopython>=1.74
  - clonalframeml>=1.13
...
#+end_example
******                                                             :B_column:
:PROPERTIES:
:BEAMER_env: column
:beamer_col: .49
:beamer_opt: t
:ID:       40fb9392-2380-4d7a-9fbf-07b8ff48b0d4
:END:
#+begin_example 
...
  - pandas
  - perl>=5.24
  - raxml>=8.2.12
  - phylip>=3.697
  - newick_utils>=1.6
  - r-base>=4.1
  - r-ape
  - r-phangorn
  - perl-bioperl>=1.7.8
#+end_example
**** Notes                                                         :B_noteNH:
:PROPERTIES:
:BEAMER_env: noteNH
:ID:       ead86a10-5908-42e3-a43e-19b6fc9bbde8
:END:
The software environment is encoded in a yaml file to be consumed by the conda package manager. Note that here I specify the exact version of
each package but not the build tag to make it transferrable to other operating systems.
The aligner, =progressiveMauve= is not included because the
version available on conda did not work with the rest of the codes and I used the version available on the Debian package archive.
Regarding the software environment,
So it becomes clear that multiple pieces of software need to be installed on the system. I used conda to resolve all dependencies and
version requirements, here is a glance at the environment definition file. 
** Workflow                                                         :B_frame:
:PROPERTIES:
:BEAMER_env: frame
:ID:       ef63b778-fa89-4193-b5b9-e1df85137bdd
:END:
***                                                               :B_onlyenv:
:PROPERTIES:
:BEAMER_env: onlyenv
:beamer_act: <1>
:ID:       1b3dcc70-78e3-4478-be58-c78d7ef2d158
:END:
****                                                                :B_block:
:PROPERTIES:
:BEAMER_env: block
:beamer_col: .49
:beamer_opt: t
:ID:       68111e52-2f56-4812-ac5a-8b83291516af
:END:
- data processing performed in multiple steps
- iterative
- multiple branches
- amplifies the problem of version matching
- additional challenge for documentation and logging
****                                                                :B_block:
:PROPERTIES:
:BEAMER_env: block
:beamer_col: .49
:beamer_opt: t
:ID:       0728b8e1-1807-423c-a561-17a2d68c477d
:END:

#+DOWNLOADED: screenshot @ 2024-10-23 16:46:56
#+attr_latex: :height .5\textheight
#+name: workflow
#+caption: \parencite{Antunes2024}
[[file:images/2024-10-23_16-46-56_screenshot.png]]
**** Notes                                                         :B_noteNH:
:PROPERTIES:
:BEAMER_env: noteNH
:ID:       4b3fc649-59ca-460d-8d00-e9a0c3d4b984
:END:
At a higher level, the need to combine multiple codes in a workflow or processing pipeline reiterates the need for proper documentation. Managing the flow of data across many different
programs, potentially with need for reformatting, parallel execution of several pipeline branches, orchestration of pipeline execution on high performance computing clusters and batch farms make utilization
of a modern workflow management system indispensable.
***                                                               :B_onlyenv:
:PROPERTIES:
:BEAMER_env: onlyenv
:beamer_act: <2>
:ID:       4048f9b6-999c-4b36-bf4a-74c80dd5648d
:END:
****                                                                :B_block:
:PROPERTIES:
:BEAMER_env: block
:beamer_col: .49
:beamer_opt: t
:ID:       f0844f9c-c392-4f48-a2cd-4ac8c63f7215
:END:
- manage input/output streams between processes
- map workflow nodes to compute request on HPC/HTC systems
- manage package dependencies
****                                                                :B_block:
:PROPERTIES:
:BEAMER_env: block
:beamer_col: .49
:beamer_opt: t
:ID:       ce356819-7295-4249-9f93-df921e991c30
:END:
- make
- snakemake
- nextflow
- galaxy
- KBase
- knime, orange
**** Notes                                                         :B_noteNH:
:PROPERTIES:
:BEAMER_env: noteNH
:ID:       1cd7a85d-a45e-4054-a1dc-48ad1b0414dc
:END:
Conducting the flow of data between multiple applications, including parallel
and asynchronous processing is greatly facilitated by a workflow managing system
such as snakemake (which builds on the ideas of the make utility to track the
state and create/modify timestamps of files or directories) or nextflow or more
graphical systems like galaxy, knime or orange. CWL is an attempt to provide a kind
of programming language as a common basis for higher level frameworks.
***                                                               :B_onlyenv:
:PROPERTIES:
:BEAMER_env: onlyenv
:beamer_act: <3>
:ID:       28010d78-47e4-4f9a-a203-ee402e38bc45
:END:
**** =Snakefile=
:PROPERTIES:
:BEAMER_env: block
:ID:       ba9bdcae-5e4a-417a-af68-7820ecfc86b9
:END:
*****                                                             :B_columns:
:PROPERTIES:
:BEAMER_env: columns
:ID:       23095baa-1a6a-4a71-84bd-ee836001bf4d
:END:
******                                                             :B_column:
:PROPERTIES:
:BEAMER_env: column
:beamer_col: .49
:beamer_opt: t
:ID:       23896e23-1e14-4ccf-a200-9e9693e9bbcd
:END:
#+beamer:{\tiny 
#+begin_example
from glob import glob
gzstrains = glob("../genomes/*.fn.gz")
strains = [fngz.replace(".fn.gz", "") for fngz in gzstrains]
fnstrains = [os.path.join('genomes', os.path.basename(st)+".fn")
             for st in strains]

rule decompress:
    input:
        expand("{gzstrain}", gzstrain=gzstrains)
    output:
        expand("{fnstrain}", fnstrain=fnstrains)
    shell:
        "gunzip -k ../genomes/*.fn.gz && mv ../genomes/*.fn genomes/"

rule mauve_align:
    input:
        expand("{fnstrain}", fnstrain=fnstrains)
    output:
        "out/01-alignment/alignment.xmfa",
        "out/01-alignment/alignment.xmfa.bbcols",
        "out/01-alignment/alignment.xmfa.backbone"
    shell:
        "progressiveMauve --output {output[0]} {input}"

...
#+end_example
#+beamer:}
******                                                             :B_column:
:PROPERTIES:
:BEAMER_env: column
:beamer_col: .49
:beamer_opt: t
:ID:       596a92c7-bc41-494e-a785-f9872df09aef
:END:
#+beamer:{\tiny
#+begin_example
...
rule raxml_tree:
    input:
        "out/05-clean_strainnames/alignment.fasta"
    output:
        "out/06a-raxml/parsimony.nwk",
        "out/06a-raxml/raxml.log",
        "out/06a-raxml/result.txt",
        "out/06a-raxml/info.txt",
        "out/06a-raxml/best_tree.nwk"
    threads: 24
    shell:
        "raxmlHPC-PTHREADS -T {threads}  -s {input} -m GTRGAMMAI -p 1 -n raxml && "
        "mv -v RAxML_parsimonyTree.raxml out/06a-raxml/parsimony.nwk; "
        "mv -v RAxML_log.raxml out/06a-raxml/raxml.log; "
        "mv -v RAxML_result.raxml out/06a-raxml/result.txt; "
        "mv -v RAxML_info.raxml out/06a-raxml/info.txt; "
        "mv -v RAxML_bestTree.raxml out/06a-raxml/best_tree.nwk"
rule cfml_analyze:
    input:
        "out/06a-raxml/best_tree.nwk",
        "out/05-clean_strainnames/alignment.fasta"
    output:
        "out/07-cfml/cfml.em.txt",
        "out/07-cfml/cfml.importation_status.txt",
        "out/07-cfml/cfml.labelled_tree.newick",
        "out/07-cfml/cfml.ML_sequence.fasta",
        "out/07-cfml/cfml.position_cross_reference.txt"
    shell:
        "ClonalFrameML {input} cfml && "
        "mv -v cfml.*.* out/07-cfml/"

rule cfml_plots:
    params:
        cfml_base = "out/07-cfml/cfml"
    input:
        "out/07-cfml/cfml.em.txt",
        "out/07-cfml/cfml.importation_status.txt",
        "out/07-cfml/cfml.labelled_tree.newick",
        "out/07-cfml/cfml.ML_sequence.fasta",
        "out/07-cfml/cfml.position_cross_reference.txt"
    output:
        "out/07-cfml/genome_tree_heatmap.pdf"
    shell:
        "../src/cfml_results.R {params.cfml_base} && " 
        "mv {params.cfml_base}.cfml.pdf {output}"
#+end_example
#+beamer:}

**** Notes                                                         :B_noteNH:
:PROPERTIES:
:ID:       74f9e8cb-f9fe-4c6f-88da-6dfb74866b70
:BEAMER_env: noteNH
:END:
The workflow itself is defined in snakemake. It consists of the seven steps outlined above, defined in a Snakemake file. Note how
output of one step becomes input in the next step.
***                                                               :B_onlyenv:
:PROPERTIES:
:BEAMER_env: onlyenv
:beamer_act: <4>
:ID:       f85a91fb-8540-434c-8833-9d9b03c4c581
:END:
**** =Snakefile=
:PROPERTIES:
:ID:       bb136c96-3c05-466f-97db-aa6d72f3bb66
:END:
#+attr_latex: :width .8\textwidth
file:Snakefile.rulegraph.png
**** Output files                                                   :B_block:
:PROPERTIES:
:BEAMER_env: block
:beamer_col: .49
:beamer_opt: t
:ID:       fe1763c6-b2dc-4c37-86e7-a3256826948a
:END:
#+begin_example
$> ls -1 out
01-alignment/
02a-stripLCBs/
02b-stripGaps/
03-concat/
04-ambig_replace/
05-clean_strainnames/
06a-raxml/
07-cfml/
#+end_example
**** Notes                                                         :B_noteNH:
:PROPERTIES:
:BEAMER_env: noteNH
:ID:       8ed15995-600d-4d83-bd10-2dd5d9be1167
:END:
One virtue of using snakemake or any other workflow manager is that output becomes neatly organized in separate directories according
to the specified output paths in the snakefile. No need to create and clean these directories, snakemake takes care of everything.
** Software Archiving                                               :B_frame:
:PROPERTIES:
:ID:       6689484a-c7f0-44c3-a9c5-629ab6056e3b
:BEAMER_env: frame
:END:
***                                                                 :B_block:
:PROPERTIES:
:BEAMER_env: block
:ID:       638d26d8-b220-4722-bebe-7ae486a01134
:END:
#+attr_latex: :height .7\textheight
#+caption: @quentinnuk@reddit.com
[[file:images/lg65bfqncy431.jpg]]
*** Notes                                                          :B_noteNH:
:PROPERTIES:
:BEAMER_env: noteNH
:ID:       40a2f9e5-2387-4797-a68c-c03edc89c304
:END:
So how do we now preserve the entire stack consisting of our software, its
dependencies, the workflow, documentation, maybe even raw and processed data?
There are essentially three options. The first option is the most reliable,
store away the entire hardware with all installed dependencies and the code
itself, ready to be re-executed when plugged into a socket and switched on. Can
be a little expensive, especially if extra measures to mitigate corruption of
storage devices are envisaged, such as low temperatures or radiation shielding.
Not very practical.
** Software Archiving                                               :B_frame:
:PROPERTIES:
:ID:       fbdfdea2-38c8-4295-8ddf-5fec87fd55f8
:BEAMER_env: frame
:END:
*** Containers and Virtual Machines
:PROPERTIES:
:ID:       72ce7447-589f-46d5-8d61-f3b43fec425c
:END:
#+attr_latex: :width .8\textwidth
#+caption: \parencite{Antunes2024}
[[file:images/vm_vs_cont.png]]
*** Notes                                                          :B_noteNH:
:PROPERTIES:
:BEAMER_env: noteNH
:ID:       9aadd6c6-3a41-444d-8f6b-d4f859d8b490
:END:
The two other options are containerization and virtual machines. A virtual
machine is an entire operating system in which the application runs as one of
its processes. A software called hypervisor takes care of resource sharing
between multiple VMs and resides directly on the host hardware. This has the
advantage that legacy code that runs only in some obscure legacy operating
system can still be executed. Downside is that virtual machines are quite
resource hungry, carry significant overhead (the operating system) that draw on
the host systems resources and hence are not the premier choice if performance
is a concern. Containers on the other hand can be seen as lightweight virtual
machines running inside the host operating system. Containerized applications
package all software dependencies in one easily transferable entity (image).
Images can easily be combined as layers, something that is not possible with
virtual machines. This flexibility and modularity have greatly boosted the
usability of software archiving solutions with Docker certainly being the most
widely known system, but due to security issues with docker, Singularity and its
successor Apptainer have become dominant in the context of scientific computing
on HPC platforms, where ordinary users have no superuser privileges.
** Software Archiving                                               :B_frame:
:PROPERTIES:
:BEAMER_env: frame
:ID:       97816b3b-8692-4e19-8e3f-5c3ecdbfe014
:END:
*** Apptainer recipe                                                :B_block:
:PROPERTIES:
:BEAMER_env: block
:ID:       6164037a-a121-4098-87a1-cde81ea1adae
:END:
****                                                              :B_columns:
:PROPERTIES:
:BEAMER_env: columns
:ID:       639090ba-42ce-47cb-8f34-fd48834c15bc
:END:
*****                                                              :B_column:
:PROPERTIES:
:BEAMER_env: column
:beamer_col: .49
:beamer_opt: t
:ID:       68970a09-d188-4d54-a3fa-2a21ea333004
:END:
#+beamer:{\tiny
#+begin_example
Bootstrap: docker
From: debian:12.7-slim

Stage: build

%files
  $PWD/environment.yml environment.yml
  $PWD/Snakefile Snakefile
  
%post
 apt update
 apt upgrade -y
 apt install -y progressivemauve curl
 apt install -y curl
 curl -L -O "https://github.com/conda-forge/miniforge...
 bash Miniforge3-$(uname)-$(uname -m).sh -b
 . /root/miniforge3/bin/activate
 mamba env create -n compbactgenomics --file environment.yml
 ...
#+end_example
#+beamer:}
*****                                                              :B_column:
:PROPERTIES:
:BEAMER_env: column
:beamer_col: .49
:beamer_opt: t
:ID:       7e54c97d-b120-45ae-b8e7-da73aa018a31
:END:
#+beamer:{\tiny
#+begin_example
...
%test
 #!/usr/bin/bash

 which progressiveMauve
 which stripSubsetLCBs
 which perl
 which raxmlHPC
 which ClonalFrameML
 which Rscript

 . /root/miniforge3/bin/activate compbactgenomics
 timestamp=$(date +%Y-%m-%dT%H%M%S)
 snakemake -np --directory $timestamp cfml_plots

%runscript
 #!/usr/bin/bash

 . /root/miniforge3/bin/activate compbactgenomics
 timestamp=$(date +%Y-%m-%dT%H%M%S)
 snakemake --directory $timestamp -c all cfml_plots
#+end_example
#+beamer:}
*** Notes                                                          :B_noteNH:
:PROPERTIES:
:BEAMER_env: noteNH
:ID:       c7bd9a8a-c348-454c-84c1-4edaef555bdb
:END:
All components, the environment, build instructions, a test, and the command to run the entire pipeline are then
integrated in an Apptainer definition file or 'recipe'. Again, this has two benefits, the entire environment becomes easily shareable
across compute platforms and operating systems *and* the file size of a container is small compared to a complete conda environment directory tree thanks
to efficient compression in Apptainer.

** Software deposition and version control                          :B_frame:
:PROPERTIES:
:ID:       f8449122-bbfc-4bb0-8186-ce8ea92e261f
:BEAMER_env: frame
:END:

*** Columns                                                       :B_columns:
:PROPERTIES:
:BEAMER_env: columns
:ID:       b73d7f1d-497f-4beb-a9de-ccffe311bd17
:END:
**** Column                                                        :B_column:
:PROPERTIES:
:ID:       98cfc69f-8743-4c66-b7a2-3c0f6cda5f48
:BEAMER_env: column
:beamer_col: .49
:beamer_opt: t
:END:
***** GitLab Repo                                                   :B_block:
:PROPERTIES:
:BEAMER_env: block
:ID:       3b36dc50-34aa-4474-9e3c-98f90a6d5146
:END:

#+attr_latex: :height .6\textheight
[[file:img/Factors_reducing_reproducibility_in_scientific_computing/2025-01-07_10-02-39_screenshot.png]]

**** Column                                                        :B_column:
:PROPERTIES:
:BEAMER_env: column
:beamer_col: .49
:beamer_opt: t
:ID:       757f5715-6053-4732-b6bb-0df184f325d4
:END:
***** Installation from GitLab                                      :B_block:
:PROPERTIES:
:BEAMER_env: block
:ID:       4cd3a795-9b7e-4cc2-854c-fbd27fa748cf
:END:
#+beamer:{\tiny
#+begin_example shell
git clone \
git@gitlab.gwdg.de:mpievolbio-scicomp/CompBactFlow.git
cd CompBactFlow
conda env create \
      -n compbactgenomics \
      --file environment.yml
#+end_example
#+beamer:}
*****                                                          :B_alertblock:
:PROPERTIES:
:ID:       2f096d63-2a20-43fa-afec-ef0768a56e51
:END:
- download, install, run in 3 commands
- same libraries
- same data
- same results ?
:PROPERTIES:
:BEAMER_env: alertblock
:END:

*** Notes                                                          :B_noteNH:
:PROPERTIES:
:BEAMER_env: noteNH
:ID:       fc76af5a-134f-4efd-b3b0-6fd2075c9aa4
:END:
Speaking about version control, that's of course another measure to reduce
reproducibility limiting factors. Think of version control as an unlimited undo/redo button with support for branching and merging different lines
of development including your collaborator's work and doing all that in a asynchronous distributed way. Again, the technology has been around for decades but
has only really picked up with the mass availability of services like github or gitlab.
* Reproducibility of results across three compute systems
:PROPERTIES:
:ID:       df705a3b-592a-4b4e-9e8b-58db0844dcbf
:END:
** Headline                                                     :B_fullframe:
:PROPERTIES:
:BEAMER_env: fullframe
:ID:       8e43426f-f3a6-45f8-a095-d64b6376dcf0
:END:
#+begin_export beamer
\begin{center} \vspace*{\fill}\Huge\insertsection\vspace*{\fill}
\end{center}
#+end_export
** Experiment setup                                                 :B_frame:
:PROPERTIES:
:BEAMER_env: frame
:ID:       f670b437-3d36-422e-9d71-5122201ada37
:END:
***                                                               :B_columns:
:PROPERTIES:
:BEAMER_env: columns
:ID:       070ed52b-03ec-42aa-b005-0c3d978c55e6
:END:
****                                                               :B_column:
:PROPERTIES:
:BEAMER_env: column
:beamer_col: .49
:beamer_opt: t
:ID:       8c6e5e24-6070-49fe-8a31-bca42ce107c9
:END:
***** Available compute infrastructures                             :B_block:
:PROPERTIES:
:BEAMER_env: block
:ID:       f1427885-71ff-40a7-9ae2-29a957e21618
:END:
#+begin_export beamer
\begin{description}
  \item["PLÖ"] Single node server DeepBio
  \item["M"] MPCDF HPC Cluster Raven
  \item["GÖ"] GWDG HPC Cluster SCC 
\end{description}
#+end_export
****                                                               :B_column:
:PROPERTIES:
:BEAMER_env: column
:beamer_col: .49
:beamer_opt: t
:ID:       04956fbf-098d-4f50-b82d-284814abb143
:END:
***** Single run                                                    :B_block:
:PROPERTIES:
:BEAMER_env: block
:ID:       a54f036c-0765-41e6-b77a-dae7fcf4e9ef
:END:

#+beamer:\tiny{
#+begin_example
#!/bin/bash
#SBATCH -p medium               # 'medium' queue
#SBATCH -N 1                    # 1 Node
#SBATCH -n 1                    # 1 task
#SBATCH -c 24                   # 24 CPUs per task
#SBATCH --mem 24G               # 24 GB

#SBATCH -t 12:00:00             # 12hrs
#SBATCH --mail-type=ALL         # Send all mails
#SBATCH --out job.%j.out        # Write stdout to job.<job-id>.out
#SBATCH --err job.%j.err        # Write errors to job.<job-id>.err
 
module load apptainer           # Load apptainer module

# Run default runscript
apptainer run --bind /local,/user,/home,/scratch  app.sif 
#+end_example
#+beamer:}
*** Notes                                                          :B_noteNH:
:PROPERTIES:
:BEAMER_env: noteNH
:ID:       b4516566-0e18-4ca8-bae4-1a37ce5abaf6
:END:
The systems I ran my little experiment on are three different computer systems: A desktop workstation in my office, the SCC Cluster in Göttingen,
and the Raven cluster at the MPCDF in Munich. On all systems, I issued a SLURM job with the following parameters: The job runs on a single node, I reserve
24 CPUs to be consumed by the threaded phylogeny inference code RaXML and a moderate amount of memory. Each run takes about 12 hours to complete. All systems
support execution of apptainer images as ordinary users, no superuser powers required but a few directories have to mounted manually and he exact paths
differ of course between the three systems, I'm showing here only the example for the SCC at GWDG.

* Results
:PROPERTIES:
:ID:       f3ea6ace-9c0e-429c-9208-34fdc06d3b89
:END:
** Headline                                                     :B_fullframe:
:PROPERTIES:
:BEAMER_env: fullframe
:ID:       75eee59e-5c56-4dde-91b2-39ab6cd698d3
:END:
#+begin_export beamer
\begin{center} \vspace*{\fill}\Huge\insertsection\vspace*{\fill}
\end{center}
#+end_export
*** Notes                                                          :B_noteNH:
:PROPERTIES:
:BEAMER_env: noteNH
:ID:       0bbef0c2-fb56-4cfb-8cfb-8205710d9806
:END:
In principle, and this was my maybe naive expectation, it should now become very easy to achieve the same results
in different compute environments. I did not expect bitwise reproducibility for the simple reason that the legacy codes I use (notably =progressiveMauve=)
do not allow to initialize the PRNG, nor did I employ any kind of record and replay method. What I did expect though is that the variability in results
are distributed within the error margin of the predicted posterior distributions from the Bayesian estimators. In other words, I expected the variance
in my computed data to be smaller than the variance of the posterior distributions. That however, was not the case as I will now show in the results:

** Results I                                                        :B_frame:
:PROPERTIES:
:ID:       a1c5b285-f7a1-426e-8b30-51064b86374d
:END:
*** 3 runs, launched manually                                       :B_block:
:PROPERTIES:
:BEAMER_env: block
:ID:       3e9e1c13-4793-4ab0-b411-e1e3642a39e2
:END:
#+attr_latex: :width .8\textwidth
[[file:images/results_3pilotruns.pdf]]
***                                                            :B_alertblock:
:PROPERTIES:
:BEAMER_env: alertblock
:ID:       90a7dfe3-18d5-4aef-9426-99471b47e43b
:END:
- Inconsistent across clusters
- 2/3 points agree on given cluster
*** Notes                                                          :B_noteNH:
:PROPERTIES:
:BEAMER_env: noteNH
:ID:       5d3b48fd-57da-4667-b458-f0ba5c6821c2
:END:
As a pilot experiment, I executed three jobs .
All three jobs were manually by submitting the same job script three times and there was only ever one job running at any time. Then I looked at
the output from =ClonalFrameML= and plot the resulting global parameters that indicate the probability for recombination to have happened. I did not like what I saw
because the numbers differed both between computer systems and also for a given system, there was some variance.
** Results II                                                       :B_frame:
:PROPERTIES:
:ID:       d799eb86-4e16-4946-8b91-98ae2776eca6
:END:
*** ~30 runs, launched from a shell loop                            :B_block:
:PROPERTIES:
:BEAMER_env: block
:ID:       91540f5f-1ebb-4ceb-bcf5-8602b7bf3d52
:END:
#+attr_latex: :width .8\textwidth
[[file:images/results_20241007.pdf]]
***                                                            :B_alertblock:
:PROPERTIES:
:BEAMER_env: alertblock
:ID:       513a04b5-efdb-46d8-b814-7832c55877f6
:END:
- Inconsistent across clusters
- Identical results on Munich cluster
- Göttingen cluster results split into two sets
*** Notes                                                          :B_noteNH:
:PROPERTIES:
:BEAMER_env: noteNH
:ID:       f69e9dd5-31d9-48bb-b994-2d02db69503b
:END:
I then went on and launched approx. 30 jobs on the two HPC systems Raven and SCC, this time running the =sbatch= command in a for loop. Why am I mentioning this? Well,
it seems to have made a difference. As you see, on Raven, all of the new results nicely agree and yield the same value for all 30 runs. On the SCC, the results
somehow split into two fractions. Just to make sure, the variance is again larger than the predicted variance of the posterior distributions.

** Results III                                                      :B_frame:
:PROPERTIES:
:ID:       1072d4c5-a32c-4d03-ad57-63592bebe896
:END:
*** ~30 more runs, launched from a shell loop                       :B_block:
:PROPERTIES:
:BEAMER_env: block
:ID:       aef2a9b3-3f7f-4cb5-b2a4-420110582592
:END:
#+attr_latex: :width .8\textwidth
[[file:images/results_20241008.pdf]]
***                                                            :B_alertblock:
:PROPERTIES:
:BEAMER_env: alertblock
:ID:       70e0011a-5a74-4294-983b-6e4ab0e71c7f
:END:
- Inconsistent across clusters
- Identical results on Munich cluster
- Göttingen cluster results split into three sets
- Multiple sets on Plön computer
*** Notes                                                          :B_noteNH:
:PROPERTIES:
:BEAMER_env: noteNH
:ID:       7c13a27a-2b52-4007-8034-b7b8e5c5e971
:END:
The same experiment, 30 jobs launched in a for loop was repeated two days later and the same qualitative picture emerges. The data on the SCC now
splits into three fractions, two majority fractions and one small fractions of just two points. The two majority fractions coincide with the ones from the previous
batch experiment.
** Results IV                                                       :B_frame:
:PROPERTIES:
:ID:       1072d4c5-a32c-4d03-ad57-63592bebe896
:END:
*** All runs
:PROPERTIES:
:BEAMER_env: block
:ID:       aef2a9b3-3f7f-4cb5-b2a4-420110582592
:END:
#+attr_latex: :width .8\textwidth
[[file:images/results_allsets.pdf]]
***                                                            :B_alertblock:
:PROPERTIES:
:BEAMER_env: alertblock
:ID:       70e0011a-5a74-4294-983b-6e4ab0e71c7f
:END:
- Inconsistent across clusters
- two outliers on Munich cluster
- split sets on Göttingen and Plön systems
*** Notes                                                          :B_noteNH:
:PROPERTIES:
:BEAMER_env: noteNH
:ID:       1e54bc27-59f1-4d31-a3ca-011dc42f1120
:END:
Putting it all together, it remains to be stated that
1.) On a given server, the results spread across a domain that is large against the predicted posterior variance. The raven system at least gives consistent
results for all runs submitted in batch mode.
2.) Results are very much not reproducible when compared among the different compute systems.
3.) The data are discretely distributed, not continuously as would be expected from prng effects or other noise impacts.
** Takeaways                                                        :B_frame:
:PROPERTIES:
:BEAMER_env: frame
:ID:       f50158c8-5522-452d-8563-7afcd6ee0864
:END:

*** Despite following best practices                                :B_block:
:PROPERTIES:
:BEAMER_env: block
:ID:       eead4aab-8417-48c5-9240-857820d57845
:END:
- Variation between and within 3 compute services
- Discretely distributed results
- Not consistent with inferred posterior distributions
- MPCDF Raven produces identical results if jobs launched in a shell loop
*** Maybe it's just me, but ...                                :B_alertblock:
:PROPERTIES:
:BEAMER_env: alertblock
:ID:       30fe8da6-9385-46df-8896-d5c73fb71536
:END:
... how can we expect researchers to achieve reproducible HPC
if a dedicated service scientist can't get it right?
*** Notes                                                          :B_noteNH:
:PROPERTIES:
:BEAMER_env: noteNH
:ID:       d93d2fd3-990e-413c-a970-6dff1eb9fe70
:END:
:LOGBOOK:
CLOCK: [2024-11-05 Tue 08:42]--[2024-11-05 Tue 09:07] =>  0:25
:END:
Now, what does this mean? Of course, I cannot rule out that I committed some stupid mistake that messed up the results. Possible, that
the bifurcating behaviour observed on some systems is caused by some kind of let's call it instability in the algorithm. Still, why do the
results differ so much across different computer systems? Again, I cannot control the random number generator, but I would have expected a more
evenly distributed results set than these discrete spikes. So let's assume for a moment, there was a way to achieve fully reproducible results or
at least results that are consistent with the inferred posterior distributions. This raises another and I dare to say in the context of this
workshop more interesting question: If a dedicated support scientist who's job it is to make computational stuff work can't figure out how to
get it right, then how on earth can we expect scientists, PhD students fighting to get their thesis done in time, PostDocs struggling to get a paper out so
they can apply for the next grant, to achieve reproducible computing?
* Backmatter
:PROPERTIES:
:ID:       beb25a13-b84d-4038-b92e-0acb253a12db
:END:
** Summary                                                          :B_frame:
:PROPERTIES:
:BEAMER_env: frame
:ID:       af0a22af-a6a6-4992-a913-c20c7034f622
:END:
***                                                                 :B_block:
:PROPERTIES:
:BEAMER_env: block
:ID:       f081f347-1552-461f-b89b-50cb7cd8c305
:END:
#+attr_beamer: :overlay <+->
- Reproducibility seems hard to achieve
- Local and centralized service facilities provide numerous infrastructures and services
- These are far from being self-explaining and user friendly
- Require expert level computing skills (and beyond)
*** Notes                                                          :B_noteNH:
:PROPERTIES:
:BEAMER_env: noteNH
:ID:       fcb53742-ed3e-474a-b571-1b6dfe70d41f
:END:
In summary I believe it's fair to say that reproducibility in computing,
especially but not exclusively in high performance computing, is not an easy
task. Things have gotten a lot better than maybe 10 or even 20 years ago but
we're still a long fetch from a work environment and culture where
reproducibility. In particular, the level of support and the provided
infrastructure locally at the institutes but maybe more importantly the
centrally provided services are top notch. We have access to some of the world
finest compute infrastructures without even having to apply for compute time (up
to a certain degree). But I'd also say that the point about "Making it easy"
requires more effort. As I may have demonstrated, leaving it to the scientists
is asking for a lot given the current state of affairs.


How to address this? This now brings us to the second part of this "workshop"
and now it's your turn: What I want to invite you to do for the next 15-30
minutes or so is to use your laptop, tablet or smartphone add your questions (or
answers). What are YOUR questions regarding Good Scientific Practice, in general
but also with respect to Software Engineering and or for High Performance
Computing? How, in your institute, in your group, in your own projects do you
deal with software engineering, with knowledge transfer, with proper usage of
computing infrastructure?

** Acknowledgements                                                 :B_frame:
:PROPERTIES:
:BEAMER_env: frame
:ID:       3cbae10b-a760-4f21-b62c-580b6f35eb27
:END:
:LOGBOOK:
CLOCK: [2024-11-05 Tue 09:13]--[2024-11-05 Tue 09:38] =>  0:25
:END:
*** Many thanks to ...                                              :B_block:
:PROPERTIES:
:ID:       84cf5134-02b9-4e9a-9a2e-93724e6babce
:BEAMER_env: block
:END:
:LOGBOOK:
CLOCK: [2024-11-05 Tue 09:44]--[2024-11-05 Tue 09:48] =>  0:04
:END:
#+beamer:{\small
- Kaumudi, Dave for involving me in their project
\pause
- MPCDF and GWDG for outstanding support
\pause
- Paul for letting me do all this (and more)
#+beamer:}
* References
:PROPERTIES:
:ID:       8f3c3e27-ddb3-4df8-8811-27eb69870473
:END:
:LOGBOOK:
CLOCK: [2024-11-05 Tue 09:48]--[2024-11-05 Tue 10:09] =>  0:21
:END:
**                                                              :B_fullframe:
:PROPERTIES:
:BEAMER_env: fullframe
:ID:       7100defb-44f5-416d-9b96-97588822a015
:END:
#+begin_export beamer
\begin{center} \vspace*{\fill}\Huge\insertsection\vspace*{\fill}
\end{center}
#+end_export
**                                                              :B_fullframe:
:PROPERTIES:
:BEAMER_env: fullframe
:ID:       ea7d98f8-fd61-4e03-8ebf-0bfdb6fb635e
:END:
#+begin_export beamer
\printbibliography
#+end_export

